Package org.eclipse.rdf4j.federated.algebra

## Class ExclusiveArbitraryLengthPath

- java.lang.Object
- - org.eclipse.rdf4j.query.algebra.AbstractQueryModelNode
  - - org.eclipse.rdf4j.query.algebra.ArbitraryLengthPath
    - - org.eclipse.rdf4j.federated.algebra.ExclusiveArbitraryLengthPath

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `ExclusiveTupleExpr`, `ExclusiveTupleExprRenderer`, `FedXTupleExpr`, `QueryRef`, `VariableExpr`, `GraphPatternGroupable`, `QueryModelNode`, `TupleExpr`, `VariableScopeChange`

      public class ExclusiveArbitraryLengthPath
      extends ArbitraryLengthPath
      implements ExclusiveTupleExpr, ExclusiveTupleExprRenderer

  An `ArbitraryLengthPath` node which can be evaluated at a single node.
  Author:
    Andreas Schwarte
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ExclusiveArbitraryLengthPath​(ArbitraryLengthPath path, StatementSource owner, QueryInfo queryInfo)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ExclusiveArbitraryLengthPath` | `clone()` | Returns a (deep) clone of this query model node.
    `List<String>` | `getFreeVars()` |
    `StatementSource` | `getOwner()` |
    `QueryInfo` | `getQueryInfo()` | Retrieve the attached query information of the tuple expression
    `TupleExpr` | `toQueryAlgebra​(Set<String> varNames, BindingSet bindings)` | Returns a SPARQL algebra representation of this expression that can be inserted into a SELECT `TupleExpr`
    `String` | `toQueryString​(Set<String> varNames, BindingSet bindings)` | Returns a SPARQL string representation of this expression that can be inserted into a SELECT query.

    - ### Methods inherited from class org.eclipse.rdf4j.query.algebra.ArbitraryLengthPath

      `equals, getAssuredBindingNames, getBindingNames, getContextVar, getMinLength, getObjectVar, getPathExpression, getScope, getSignature, getSubjectVar, hashCode, replaceChildNode, setContextVar, setMinLength, setObjectVar, setPathExpression, setScope, setSubjectVar, visit, visitChildren`

    - ### Methods inherited from class org.eclipse.rdf4j.query.algebra.AbstractQueryModelNode

      `getCostEstimate, getParentNode, getResultSizeActual, getResultSizeEstimate, getTotalTimeNanosActual, isGraphPatternGroup, isVariableScopeChange, nullEquals, replaceNodeInList, replaceWith, setCostEstimate, setGraphPatternGroup, setParentNode, setResultSizeActual, setResultSizeEstimate, setTotalTimeNanosActual, setVariableScopeChange, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.federated.algebra.FedXTupleExpr

      `getFreeVarCount`

    - ### Methods inherited from interface org.eclipse.rdf4j.query.algebra.QueryModelNode

      `equals, getCostEstimate, getParentNode, getResultSizeActual, getResultSizeEstimate, getSignature, getTotalTimeNanosActual, replaceChildNode, replaceWith, setCostEstimate, setParentNode, setResultSizeActual, setResultSizeEstimate, setTotalTimeNanosActual, toString, visit, visitChildren`

    - ### Methods inherited from interface org.eclipse.rdf4j.query.algebra.TupleExpr

      `getAssuredBindingNames, getBindingNames`

- - ### Constructor Detail

    - #### ExclusiveArbitraryLengthPath

          public ExclusiveArbitraryLengthPath​(ArbitraryLengthPath path,
                                              StatementSource owner,
                                              QueryInfo queryInfo)

  - ### Method Detail

    - #### getOwner

          public StatementSource getOwner()

      Specified by:
        `getOwner` in interface `ExclusiveTupleExpr`
      Returns:
        the owner for this expression

    - #### clone

          public ExclusiveArbitraryLengthPath clone()

      Description copied from interface: `QueryModelNode`
      Returns a (deep) clone of this query model node. This method recursively clones the entire node tree, starting from this nodes.
      Specified by:
        `clone` in interface `QueryModelNode`
      Specified by:
        `clone` in interface `TupleExpr`
      Overrides:
        `clone` in class `ArbitraryLengthPath`
      Returns:
        A deep clone of this query model node.

    - #### toQueryString

          public String toQueryString​(Set<String> varNames,
                                      BindingSet bindings)

      Description copied from interface: `ExclusiveTupleExprRenderer`
      Returns a SPARQL string representation of this expression that can be inserted into a SELECT query.

      Implementations are required to create a valid query string for this expression where the given bindings are inserted.

      Specified by:
        `toQueryString` in interface `ExclusiveTupleExprRenderer`
      Parameters:
        `varNames` - the set of resulting (unbound) variables from this expression
        `bindings` - the optional input bindings
      Returns:
        the query string part

    - #### toQueryAlgebra

          public TupleExpr toQueryAlgebra​(Set<String> varNames,
                                          BindingSet bindings)

      Description copied from interface: `ExclusiveTupleExprRenderer`
      Returns a SPARQL algebra representation of this expression that can be inserted into a SELECT `TupleExpr`

      Implementations are required to create a new equivalent expression or clone, where any provided input bindings are inserted. The free variable names after insertion need to be added to the provided set.

      Specified by:
        `toQueryAlgebra` in interface `ExclusiveTupleExprRenderer`
      Parameters:
        `varNames` - the set of resulting (unbound) variables from this expression
        `bindings` - the input bindings that need to be inserted
      Returns:
        the algebra expression

    - #### getFreeVars

          public List<String> getFreeVars()

      Specified by:
        `getFreeVars` in interface `VariableExpr`
      Returns:
        a list of free (i.e. unbound) variables in this expression

    - #### getQueryInfo

          public QueryInfo getQueryInfo()

      Description copied from interface: `QueryRef`
      Retrieve the attached query information of the tuple expression
      Specified by:
        `getQueryInfo` in interface `QueryRef`
      Returns:
        the `QueryInfo`